******************************************************************************
*  No Copyright, released to the Public Domain
*
*  $Workfile:   y2kcomp.prg  $
*
*  Programmer.: The Ghost in the Machine
*  Date.......: 10/22/98
*  Description: Y2KCODE.EXE generated comments for Y2K remediation herein
*
*  *** PVCS revision log section - Do not modify! ***
*  $Log:   N:\vcs\source\exec\y2kcomp.prv  $
*
*     Rev 34.6   01 Oct 2000 16:03:36   GRLTC25
*  Improved MAK file and #include's so that each PRG is more independent.
*  Also: Corrected sampling for text reports and delimited files.
*
*     Rev 34.5   27 Nov 1998 13:16:38   GRLTC25
*  Added additional date-range adjustment method "two year"
*
*     Rev 34.4   03 Nov 1998 15:23:44   GRLTC26
*  fix problem with SET DEFAULT setting.  Should now correctly
*  find files relative to the directory you run the program from
*
*     Rev 34.3   03 Nov 1998 09:54:40   GRLTC26
*  allow long pathnames and relative addressing
*
*     Rev 34.2   26 Oct 1998 16:45:26   GRLTC25
*  Added endorsement boilerplate
*
*     Rev 34.1   26 Oct 1998 12:13:02   GRLTC25
*  Added date fudge to accomodate extra day aging around 2/28/2000
*
*     Rev 34.0   22 Oct 1998 11:44:50   GRLTC25
*  Initial revision.
*
******************************************************************************
#include "Y2KComp.ch"

MEMVAR glLeapSkip
MEMVAR getlist
MEMVAR gcAdjust

//Main()

*----------------------------------------------------------------------------
FUNCTION Main(p1)
*----------------------------------------------------------------------------
LOCAL cType, cFreq, cCycle
LOCAL c1 := SPACE(80), c2 := SPACE(80)
LOCAL cGMBO := SPACE(4)
LOCAL cName := SPACE(19)
LOCAL aCycle := { "Unit Test", "Regression Test",                              ;
                  "1999 Positive Test", "2000 Positive Test" }
LOCAL aTypes := {_TYPE_DBF, _TYPE_TXT, _TYPE_DLM, _TYPE_FLT, _TYPE_FOO}
LOCAL aFreq :=  {_FREQ_1, _FREQ_3, _FREQ_10, _FREQ_50, _FREQ_250, _FREQ_1000}
LOCAL nType, nFreq, nCycle

PUBLIC glLeapSkip := .T.

// Decide what date-range adjustment method to use
PUBLIC gcAdjust
IF EMPTY(p1)
    gcAdjust := _TWOYEAR
ELSEIF "LEAP" $ UPPER(p1)
    gcAdjust := _LEAPDAY
ELSEIF "NO" $ UPPER(p1)
    gcAdjust := _NOADJUST
ELSE
    gcAdjust := _TWOYEAR
ENDIF

SET( _SET_DEFAULT, ".\")

CLS
DO WHILE .NOT. FILE(ALLTRIM(c1)) .OR. .NOT. FILE(ALLTRIM(c2))
    @ 2,5  SAY "Project GMBO Number:"       GET cGMBO PICT "!!!!"
    @ 2,32 SAY "Comparison Assignee:"       GET cName
    @ 4,5  SAY "Select Comparison File 1: " GET c1 PICT "@S40!"
    @ 6,5  SAY "Select Comparison File 2: " GET c2 PICT "@S40!"
    READ
    IF LASTKEY()=27
        QUIT
    ENDIF
ENDDO

// Get the comparison type, sampling frequency and test cycle (quit if ESC)
IF 0 = (nType := ACHOICE(10,05,17,28,aTypes))
    QUIT
ELSE
    @ 8,5  SAY (cType := aTypes[nType]) COLOR "N/W"
ENDIF

IF 0 = (nFreq := ACHOICE(10,32,17,45,aFreq))
    QUIT
ELSE
    @ 8,32 SAY (cFreq := aFreq[nFreq]) COLOR "N/W"
ENDIF

IF 0 = (nCycle := ACHOICE(10,50,17,71,aCycle))
    QUIT
ELSE
    @ 8,50 SAY (cCycle := aCycle[nCycle]) COLOR "N/W"
ENDIF

SET CURSOR OFF
Compare(cType, ALLTRIM(c1), ALLTRIM(c2), cGMBO, cCycle, cFreq, cName)

CLOSE ALL
@23,0 SAY ""
? ""
RETURN nil


*----------------------------------------------------------------------------
FUNCTION Meter(nWhat, nAmt)
*----------------------------------------------------------------------------
LOCAL i
LOCAL nTop   := 22
LOCAL nBot   := nTop+2
LOCAL nLeft  := 0
LOCAL nRight := nLeft+MAXCOL()
LOCAL nWide  := nRight
LOCAL nProgress

STATIC cScr
STATIC nLast := 0
STATIC nTotal := 0

IF nWhat = _TOTAL
    nTotal := nAmt
ELSEIF nWhat = _CLEAR
    @ nTop, nLeft CLEAR TO nBot, nRight
ELSEIF nWhat = _CURRENT
    nProgress := ((nAmt/nTotal) * nWide) - 1

    IF nAmt = 0
        @ nTop, nLeft, nBot, nRight BOX CHR(218)+CHR(196)+CHR(191)+CHR(179)+      ;
                                        CHR(217)+CHR(196)+CHR(192)+CHR(179)+" "   ;
                                    COLOR "W/N"
    ENDIF

    FOR i = 1 TO nProgress
        @ nTop+1, nLeft+i SAY "" COLOR "W+/N"
    NEXT i
    IF nProgress-INT(nProgress) > 0.5
        @ nTop+1, nLeft+i SAY "" COLOR "W+/N"
    ENDIF
ENDIF
RETURN nil


*----------------------------------------------------------------------------
FUNCTION SetText(c)
*----------------------------------------------------------------------------
@ 21,1 SAY SPACE(80)
@ 21,1 SAY c
RETURN nil


*----------------------------------------------------------------------------
FUNCTION SysRefresh()
*----------------------------------------------------------------------------
RETURN nil


*----------------------------------------------------------------------------
FUNCTION MsgInfo(cMess, cTitle)
*----------------------------------------------------------------------------
ALERT(cTitle + ": " + cMess)
RETURN nil


*----------------------------------------------------------------------------
FUNCTION MsgYesNo(cMess, cTitle)
*----------------------------------------------------------------------------
cTitle := IIF(cTitle== NIL, "QUESTION", UPPER(ALLTRIM(cTitle)))
cMess  := IIF(cMess == NIL, "", ALLTRIM(cMess))
cMess  := cTitle +": "+cMess
RETURN IIF(1==ALERT(cMess, {"Yes", "No"}), .T., .F.)


*----------------------------------------------------------------------------
FUNCTION SayScreen(c)
*----------------------------------------------------------------------------
LOCAL i
@ 10, 03, 17, 76 BOX CHR(218)+CHR(196)+CHR(191)+CHR(179)+      ;
                     CHR(217)+CHR(196)+CHR(192)+CHR(179)+" "   ;
                 COLOR "W/N"

FOR i = 1 TO MIN(MLCOUNT(c, 70, 4, .T.), 6)
    @ 10+i, 05 SAY MEMOLINE(c, 70, i, 4, .T.)
NEXT i
INKEY(.5)
RETURN nil


*----------------------------------------------------------------------------
FUNCTION Results()
*----------------------------------------------------------------------------
MEMOWRIT("Report.TXT", Report(_FETCH))
INKEY(2)
SWPRUNCMD("EDIT REPORT.TXT")
RETURN nil


*----------------------------------------------------------------------------
FUNCTION Choice(cMess, aOpts)
*----------------------------------------------------------------------------
LOCAL nChoice, cScrn
SayScreen(cMess)
SAVE SCREEN TO cScrn
@ 14, 15, 21, 64 BOX CHR(218)+CHR(196)+CHR(191)+CHR(179)+      ;
                     CHR(217)+CHR(196)+CHR(192)+CHR(179)+" "   ;
                 COLOR "W/N"
nChoice := ACHOICE(15, 17, 20, 62, aOpts)
RESTORE SCREEN FROM cScrn
RETURN nChoice

